Deck = {
	deck: null,

	init: function () {
		this.deck = document.getElementById("content");
		},

	page: function (n) {
		try {
			with (this.deck) {
				selectedIndex = n;
				var h = selectedPanel.getAttribute("home");
				document.getElementById(h).focus();
				}
			}
		catch (e) {alert("Deck.page\n" + e);}
		}

	}



Dialog = {
	isDirty: false,

	changed: function () {
		if (!this.isDirty) {
			with (document.getElementById("cancel-button")) {
				removeAttribute("default");
				}
			with (document.getElementById("ok-button")) {
				disabled = false;
				setAttribute("default", "true");
				}
			this.isDirty = true;
			}
		},

	close: function (ok) {
		try {
			if (ok) Pref.save();
			window.close();
			}
		catch (e) {alert("Dialog.close " + e);}
		},

	// user typed current password
	gotPass: function () {
		var ok = (document.getElementById("password0-text").value != "");
		document.getElementById("recover-button").disabled = ok;
		document.getElementById("password1-text").disabled = !ok;
		document.getElementById("password2-text").disabled = !ok;
		document.getElementById("question-text").disabled = !ok;
		document.getElementById("answer-text").disabled = !ok;
		},

	init: function () {
		try {
			Deck.init();
			Pref.load();
			}
		catch (e) {alert("Dialog.init " + e);}
		},

	recover: function () {
		var p = Components
			.classes["@mozilla.org/embedcomp/prompt-service;1"]
			.getService(Components.interfaces.nsIPromptService);
		var r = {value: null};
		var ok = p.promptPassword(
				self,
				"Recover Password",
				"What's my name?",
				r,
				null,
				{});
		if (!ok) return;

		if (r.value == "Fred") {
			with (document.getElementById("password0-text")) {
				value = "recovered";
				disabled = true;
				}
			this.gotPass();
			document.getElementById("password1-text").focus();
			}
		else {
			p.alert(self, "Recover Password", "Recovery failed");
			}
		}

	}


Pref = {
	branch: Components
		.classes['@mozilla.org/preferences-service;1']
		.getService(Components.interfaces.nsIPrefService)
		.getBranch("journal."),

	field: function (id) {
		return document.getElementById(id);
		},

	load: function () {
		var v = this.value("startup.sidebar", "");
		this.field("sidebar-check").checked = (v != "");
		with (this.field("sidebar-radio")) {
			if (v != "") selectedIndex = (v == "show")? 0 : 1;
			disabled = (v == "");
			}

		v = this.value("startup.calendar", "");
		this.field("calendar-check").checked = (v != "");
		with (this.field("calendar-radio")) {
			if (v != "") selectedIndex = (v == "show")? 0 : 1;
			disabled = (v == "");
			}

		v = this.value("startup.view", "");
		this.field("view-check").checked = (v != "");
		var f = this.field("view-menu");
		switch (v) {
			case "journals":
				f.selectedItem = this.field("journals-item");
				break;
			case "diary":
				f.selectedItem = this.field("diary-item");
				break;
			case "index":
				f.selectedItem = this.field("index-item");
				break;
			case "category":
				f.selectedItem = this.field("category-item");
				break;
			}

		v = this.value("startup.login", "");
		this.field("login-invite").checked = (v != "");
		this.field("login-require").checked = (v == "require");

		this.field("owner-text").value = this.value("username", "Anonymous");
		this.field("question-text").value = this.value("password.question", "");

		var pw = (opener.login.hasHash(1));
		with (this.field("password0-text")) {
			value = "";
			disabled = !pw;
			}
		this.field("recover-button").disabled = !pw
		this.field("password1-text").disabled = pw;
		this.field("password2-text").disabled = pw;
		this.field("question-text").disabled = pw;
		this.field("answer-text").disabled = pw;

		},

	save: function () {
		var v = "";
		if (this.field("sidebar-check").checked)
			v = (this.field("sidebar-show-radio").selected)? "show" : "hide";
		this.set("startup.sidebar", v);
			
		},

	set: function (name, val) {
		if (val.search(/^\d/) == 0)
			this.branch.setIntPref(name, val);
		else if (val === true || val === false)
			this.branch.setBoolPref(name, val);
		else
			this.branch.setCharPref(name, val);
		},

	value: function (name, dflt) {
		try {
			var t = this.branch.getPrefType(name);
			switch (t) {
				case 0:
					return dflt;
					break;
				case 32:
					return this.branch.getCharPref(name);
					break;
				case 64:
					return this.branch.getIntPref(name);
					break;
				case 128:
					return this.branch.getBoolPref(name);
					break;
				}
			}
		catch (e) {
			alert("Pref.value " + e);
			return dflt;
			}
		}

	}


UI = {
	clear: function (a) {	// element array
		try {
			for (var i = 0; i < a.length; ++i) {
				var e = document.getElementById(a[i]);
				var v;
				switch (e.localName) {
					case "radiogroup":
					case "menulist":
						v = e.selectedIndex;
						if (v < 0) v = null;
						e.selectedItem = null;
						break;
					case "textbox":
						v = e.value;
						e.value = "";
						break;
					case "checkbox":
						v = e.checked;
						e.checked = false;
						break;
					}
				if (v != null && !e.hasAttribute("was")) e.setAttribute("was", v);
				}
			}
		catch (e) {alert("UI.clear\n" + e);}
		},

	disable: function (a) {	// element array
		try {
			for (var i = 0; i < a.length; ++i) {
				var e = document.getElementById(a[i]);
				switch (e.localName) {
					case "menuitem":
						var m = e.parentNode.parentNode;
						var s = m.selectedItem;
						if (s == e) m.selectedItem = null;
						break;
					}
				e.disabled = true;
				}
			}
		catch (e) {alert("UI.disable\n" + e);}
		},

	enable: function (a, s) {	// element array, setting
		try {
			var d = (s == undefined)? false : !s;
			for (var i = 0; i < a.length; ++i) {
				document.getElementById(a[i]).disabled = d;
				}
			}
		catch (e) {alert("UI.enable\n" + e);}
		},

	ensure: function (a, d) {	// element array, default value
		try {
			for (var i = 0; i < a.length; ++i) {
				var e = document.getElementById(a[i]);
				switch (e.localName) {
					case "menulist":
						if (!e.hasAttribute("disabled") && e.selectedIndex < 0) e.selectedIndex = d;
						break;
					case "checkbox":
						if (e.checked != d) e.checked = d;
						break;
					}
				}
			}
		catch (e) {alert("UI.ensure\n" + e);}
		},

	focus: function (i) { // element id
		with (document.getElementById(i)) {
			focus();
			if (localName == "textbox") select();
			}
		},

	logic: function (a) {	// element array
		try {
			for (var i = 0; i < a.length; ++i) {
				with (document.getElementById(a[i])) {
					if (!hasAttribute("disabled")) logic();
					}
				}
			}
		catch (e) {alert("UI.logic " + a[i] + "\n" + e);}
		},

	restore: function (a, d) {	// element array, default
		try {
			for (var i = 0; i < a.length; ++i) {
				var e = document.getElementById(a[i]);
				var v = (e.hasAttribute("was"))? e.getAttribute("was") : d;
				switch (e.localName) {
					case "radiogroup":
					case "menulist":
						if (v != null) e.selectedIndex = v;
						break;
					case "textbox":
						if (v != null) e.value = v;
						break;
					case "checkbox":
						if (v != null) e.checked = (v == "true");
						break;
					}
				e.removeAttribute("was");
				}
			}
		catch (e) {alert("UI.restore\n" + e);}
		}
	}
