Dialog = {
	deck: null,
	info: null,
	progress: null,
	enterKey: null,
	returnKey: null,
	escapeKey: null,
	upKey: null,
	downKey: null,

	close: function (ok) {
		window.opener.login = null;
		window.close();
		},

	// display info on a standard journal
	display: function (e) {
		this.info.value = (e)? e.getAttribute("info") : "";
		},

	init: function () {
		this.deck = document.getElementById("content");
		this.info = document.getElementById("info");
		this.progress = document.getElementById("progress");

		with (Components.interfaces.nsIDOMKeyEvent) {
			enterKey = DOM_VK_ENTER;
			returnKey = DOM_VK_RETURN;
			escapeKey = DOM_VK_ESCAPE;
			upKey = DOM_VK_UP;
			downKey = DOM_VK_DOWN;
			}

		document.getElementById("name-text").focus();
		},

	// handle Enter and Return
	keypress: function (event) {
		var k = event.keyCode;
		if (k == enterKey || k == returnKey) {
			var f = document.commandDispatcher.focusedElement;
			if (f && f.localName == "button") return;
			var b = document.getElementById("buttons-box").firstChild;
			while (b) {
				if (!b.disabled && b.hasAttribute("default")) {
					switch (b.id) {
						case "cancel-button":
							this.close(false);
							break;
						case "close-button":
							this.close(true);
							break;
						case "finish-button":
							this.setup();
							break;
						case "next-button":
							this.next(true);
							break;
						}
					break;
					}
				b = b.nextSibling;
				} 
			}
		},

	// Next and Back buttons
	next: function (d) {
		var n = parseInt(this.deck.selectedIndex) + ((d)? 1 : -1);
		this.deck.selectedIndex = n;
		document.getElementById("step-number").value = n + 1;

		document.getElementById("back-button").disabled = (n == 0 || n == 3);
		document.getElementById("next-button").hidden = (n == 2 || n == 3);
		document.getElementById("finish-button").hidden = (n < 2);
		document.getElementById("finish-button").disabled = (n == 3);
		document.getElementById("close-button").hidden = (n != 3);
		document.getElementById("cancel-button").hidden = (n == 3);

		if (n == 2) {
			document.getElementById("name-confirm").value
				= document.getElementById("name-text").value;
			var j = document.getElementById("journals-list").firstChild;
			var c = document.getElementById("journals-confirm").firstChild;
			while (j) {
				if (j.checked) {
					c.value = j.getAttribute("label");
					c = c.nextSibling;
					}
				j = j.nextSibling;
				}
			while (c) {
				c.value = "";
				c = c.nextSibling;
				}
			}

		if (n == 3) {
			var l = document.getElementById("step-box").firstChild;
			while (l) {
				l.value = "";
				l = l.nextSibling;
				}
			}
	
		var f;
		switch (n) {
			case 0: f = "name-text"; break;
			case 1: f = "journal0"; break;
			case 2: f = "finish-button"; break;
			case 3: f = "close-button"; break;
			}
		document.getElementById(f).focus();
		},

	// scroll journals list
	scroll: function (event) {
		var f = document.commandDispatcher.focusedElement;
		var k = event.keyCode;
		var f1;
		if (k == downKey) {
			f1 = f.nextSibling;
			if (!f1) f1 = f.parentNode.firstChild;
			}
		else if (k == upKey) {
			f1 = f.previousSibling;
			if (!f1) f1 = f.parentNode.lastChild;
			}
		if (f1) f1.focus();
		},

	// Finish button
	setup: function () {
		const step = 10;
		var p = parseInt(this.progress.value);
		if (p < 100) {
			this.progress.value = p + step;
			switch (p / step) {
				case 0:
					window.opener.login.setup(0, document.getElementById("name-text").value, "");
					break;
				case 1:
					var j = document.getElementById("journal0");
					if (j.checked) window.opener.login.setup(1, j.getAttribute("label"), j.getAttribute("info"));
					break;
				case 2:
					var j = document.getElementById("journal1");
					if (j.checked) window.opener.login.setup(2, j.getAttribute("label"), j.getAttribute("info"));
					break;
				case 3:
					var j = document.getElementById("journal2");
					if (j.checked) window.opener.login.setup(3, j.getAttribute("label"), j.getAttribute("info"));
					break;
				}
			window.setTimeout("Dialog.setup();", 50);
			}
		else {
			window.setTimeout("Dialog.next(true);", 1000);
			}
		},

	// user names enables Next on page 1
	validate: function (e) {
		var ok = (e.value.search(/\S/) >= 0);
		document.getElementById("next-button").disabled = !ok;
		document.getElementById("cancel-button").removeAttribute("default");
		document.getElementById("next-button").setAttribute("default", "true");
		}

	}
